Content.makeFrontInterface(700, 400);


//! ============ FILTER1 LFO SAVE PRESET ============

const var tableProcessor0 = Synth.getTableProcessor("FILTER1_LFO");
const var tableData = tableProcessor0.exportAsBase64(0);


namespace PresetBrowser {
    const var LFO_Preset_Pnl0 = Content.getComponent("LFO_Preset_Pnl0"); 
    
    const var LFO_Viewport0 = Content.getComponent("LFO_Viewport0");
    LFO_Viewport0.setControlCallback(onLFO_Viewport0Control);
    
    const var LFO_ShowPresetFolder0 = Content.getComponent("LFO_ShowPresetFolder0");
    LFO_ShowPresetFolder0.setControlCallback(onLFO_ShowPresetFolder0Control);
    
    const var LFO_SavePreset0 = Content.getComponent("LFO_SavePreset0");
    LFO_SavePreset0.setControlCallback(onLFO_SavePreset0Control);
    
    const var LFO_PresetOptions0 = Content.getComponent("LFO_PresetOptions0");
    const var LFO_EnterPresName_Lbl0 = Content.getComponent("LFO_EnterPresName_Lbl0");
    
    const var LFO_SaveOk0 = Content.getComponent("LFO_SaveOk0");
    LFO_SaveOk0.setControlCallback(onLFO_SaveOk0Control);

    const var LFO_SaveCancel0 = Content.getComponent("LFO_SaveCancel0");
    LFO_SaveCancel0.setControlCallback(onLFO_SaveCancel0Control);
    
    const var LFO_SavePresClose0 = Content.getComponent("LFO_SavePresClose0");
    LFO_SavePresClose0.setControlCallback(onLFO_SavePresClose0Control); 
    
    const var LFO_PresBrowsOpener0 = Content.getComponent("LFO_PresBrowsOpener0");
	LFO_PresBrowsOpener0.setControlCallback(onLFO_PresBrowsOpener0Control);     
    
    populateLFO_Viewport0();
    

    inline function populateLFO_Viewport0() {
        local presetNames = PresetHandler.fetchPresetNames();
        LFO_Viewport0.set("items", presetNames.join("\n"));
    }
    
    inline function onLFO_Viewport0Control(component, value) {
        local items = component.get("items").split("\n");
        local preset = PresetHandler.loadPresetFile(items[value]);
        setControlValues(preset);
    };
    
    inline function onLFO_ShowPresetFolder0Control(component, value) {
        if (value) PresetHandler.showPresetFolder();
    };
    
    inline function onLFO_SavePreset0Control(component, value) {
        LFO_PresetOptions0.showControl(value);
    };
        
    inline function onLFO_SavePresClose0Control(component, value) {
    	LFO_Preset_Pnl0.showControl(false);
    };
        
    inline function onLFO_PresBrowsOpener0Control(component, value) {
    	LFO_Preset_Pnl0.showControl(true);
    };
    
    inline function onLFO_SaveOk0Control(component, value) {
        if (value) {
            local presetName = LFO_EnterPresName_Lbl0.get("text");
            PresetHandler.savePresetFile(presetName, getControlValues());
            LFO_SavePreset0.setValue(false);
            LFO_SavePreset0.changed();
            populateLFO_Viewport0();
        }
    };
    
    inline function onLFO_SaveCancel0Control(component, value) {
        LFO_SavePreset0.setValue(false);
        LFO_SavePreset0.changed();
    };
    
    inline function getControlValues() {
        return {
            "tableData": tableProcessor0.exportAsBase64(0)
        };
    }
    
    inline function setControlValues(data) {
        tableProcessor0.restoreFromBase64(0, data.tableData);
    }
}



namespace PresetHandler {
    inline function getPresetFolder() {
        return FileSystem.getFolder(FileSystem.UserPresets).getChildFile("ARP");
    }
    
	inline function fetchPresetNames() {
		local presets = FileSystem.findFiles(getPresetFolder(), "*.arp", true);
		local presetNames = [];
		for (file in presets)
			presetNames.push(file.toString(1));
			
		return presetNames;
	}

	inline function loadPresetFile(presetName) {
		local presetFile = FileSystem.findFiles(getPresetFolder(), presetName + ".arp", true);
		return presetFile[0].loadAsObject();
	}

	inline function savePresetFile(presetName, data) {
		local presetFile = getPresetFolder().getChildFile(presetName + ".arp");
		presetFile.writeObject(data);
	}

	inline function presetNameExists(presetName) {
		return getPresetFolder().getChildFile(presetName + ".arp").isFile();
	}

	inline function showPresetFolder() {
		getPresetFolder().show();
	}
}



function onNoteOn()
{
	
}
 function onNoteOff()
{
	
}
 function onController()
{
	
}
 function onTimer()
{
	
}
 function onControl(number, value)
{
	
}
 